<?php

class NetworkConfiguration extends Model
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'NetworkConfiguration';
    $this->AddPropertyString('Caption');
    $this->AddPropertyString('Execute');
    $this->AddPropertyBoolean('Changed');
    $this->AddPropertyDateTime('LastTime');
    $this->AddPropertyInteger('ExecutionTime');
    $this->AddPropertyBoolean('Enabled');
    $this->AddPropertyInteger('Period');
    $this->AddPropertyText24('Log');
  }
}

class ModuleNetworkConfig extends Module
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'NetworkConfig';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Mikrotik RouterOS configuration';
    $this->Dependencies = array('Network');
    $this->SupportedModels = array('NetworkConfiguration');
  }
  
  function Install()
  {
    parent::Install();
  }
  
  function UnInstall()
  {
    parent::UnInstall();
  }

  function Init()
  {
  }
}


?>